#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include<stdint.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <signal.h>
#include <sys/stat.h>
#include <strings.h>
#define PORT 8080
#define MAX_CONNECTION 5



int sockfd;
int puerto;
char pagina[500], directorio[500], usuario[50], password[50], *ext, mime[500];


void error(const char *msg)
{
    	perror(msg);
    	exit(1);
}


int leer_fichero (void){
	FILE *fichero;
	fichero= fopen ("fichero.config","r");
 	if (fichero == NULL)
    	{
        	printf("Error abriendo fichero.config");
        	return -1;
    	}
	fscanf (fichero, "%d\n%s\n%s\n" , &puerto, pagina, directorio);
	return 0;
} 


void process_request(int newsockfd){
	char buffer[3000],metodo[300], recurso[400],version[400], ruta[2000], cabecera[4000], buffer_aux[3000];
	socklen_t clilen;
	struct stat info;
	struct sockaddr_in cli_addr;

	int n;
	FILE *fp;
	clilen = sizeof(cli_addr);
	bzero(buffer,3000);

	/*leemos del socket hasta 3000 bytes*/
	n = read(newsockfd,buffer,3000);
	if (n < 0) 
		error("ERROR reading from socket");
	printf("Here is the message: %s\n",buffer);

	/*comprobamos que es GET*/
	sscanf(buffer, "%s %s %s",metodo, recurso, version);

	if (strcmp(metodo,"GET")==0){
 		if (strcmp(version,"HTTP/1.1")==0 || strcmp(version, "HTTP/1.0")==0) 
		{
			if(strcmp(recurso,"/")==0)
			{
				strcpy(ruta,directorio);
				strcat(ruta,pagina);

				if (stat(ruta, &info)!=0)
					ext=strstr(ruta,".");
				
				/*devolvemos la respuesta*/
				sprintf(cabecera, "%s200 OK\r\nContent-Type:%s\r\nContent-lenght:%ld\r\n", version, mime, info.st_size );
				write(newsockfd, cabecera, strlen(cabecera));
				int tam=0;

				if (n < 0) 
					error("ERROR writing to socket");
				fp=fopen(ruta,"r");

				while (tam<info.st_size){
					n= fread(buffer_aux, 1, 1000, fp);
					tam +=n;
					write(newsockfd, buffer_aux, n);
				}



			}

			else
			{
				strcpy(ruta,directorio);
				strcat(ruta,recurso);
			}
   			if (stat(ruta, &info)!=0)
				ext=strstr(ruta,".");
			if(ext==NULL)
				sprintf(mime,"application/octet-stream");
			else
				get_mime();
			

}
	sprintf(cabecera, "%s200 OK\r\nContent-Type:%s\r\nContent-lenght:%ld\r\n", version, mime, info.st_size );
	write(newsockfd, cabecera, strlen(cabecera));
	int tam=0;
	
	
	

	/*devolvemos la respuesta*/
	n = write(newsockfd,"I got your message\n",19);
	if (n < 0) 
		error("ERROR writing to socket");
	fp=fopen(ruta,"r");
	while (tam<info.st_size){
	n= fread(buffer_aux, 1, 1000, fp);
	tam +=n;
	write(newsockfd, buffer_aux, n);
	}
	fclose(fp);

}
	/*cerramos el socket nuevo que se ha creado en el otro sentido*/
	close(newsockfd);
}

void handle(int nsignal){
	printf("server is shutting down now\n");
	close(sockfd);
	exit(0);
}

int get_mime(void)
{

	FILE *f;
	char cadena[255];
	f=fopen("/etc/mime.types","r");
	char *aux=NULL;
	int n=0;
	char extension[100];
        /*Leemos cada linea de fichero*/
	while(fgets(cadena,255,f)!=NULL)
	{
                /*Si la linea empieza por # es un comentario y no hay que leerlo.*/
		if(cadena[0]!='#')
		{
                        /*partimos la cadena para obtener el mime type (1º columna)*/
			aux=strtok(cadena,"\t");
			if(aux)
			{
				strcpy(mime,aux);
                                /*Partimos cada parte de la cadena restante (extensiones) y comprobamos si
                                coincide la extension que leemos con la que tenemos almacenada en ext.*/
				while(aux!=NULL)
				{
					aux=strtok(NULL,"\t \n");
					if((aux))
					{
						strcpy(extension,aux);
						if(strcmp(extension,ext)==0)
							printf("%s\n",mime);
					}
				}
			}	
		}

	}

	fclose(f);

}


int main(int argc, char *argv[])
{
	int portno;
	struct sockaddr_in serv_addr,cli_addr;
	int n, newsockfd;

	/* Crear un socket para manejar conexiones TCP*/
	sockfd = socket(AF_INET, SOCK_STREAM, 0);
	if (sockfd < 0) 
		error("ERROR opening socket");

	/* Preparar una estructura con informacion sobre como vamos
	a recibir las conexiones TCP
	En este ejemplo, enlazaremos el socket a la IP local al puerto TCP PORT
	Esto lo conseguiremos inicializando
	la estructura a cero mediante, por ejemplo, 'bzero'.*/
	bzero((char *) &serv_addr, sizeof(serv_addr));

	leer_fichero();
	portno = puerto;
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = INADDR_ANY;
	serv_addr.sin_port = htons(portno);
	if (bind(sockfd, (struct sockaddr *) &serv_addr,sizeof(serv_addr)) < 0) 
		error("ERROR on binding");

	/* Activaremos una propiedad del socket que permitira que otros
	 sockets puedan reutilizar cualquier puerto al que nos enlacemos.
	 Esto permitira en protocolos como el TCP, poder ejecutar un
	 mismo programa varias veces seguidas y enlazarlo siempre al
	 mismo puerto. De lo contrario habria que esperar a que el puerto
	 quedase disponible (TIME_WAIT en el caso de TCP)*/
	if (setsockopt(sockfd,SOL_SOCKET,SO_REUSEADDR,&serv_addr,sizeof(struct sockaddr_in))==-1)
	{
 		error("ERROR: Fallo al reutilizar el puerto.\n");
	}

	/* Habilitar socket para recibir conexiones */
	if (listen(sockfd, MAX_CONNECTION) == -1){
		printf("Error en listen\n");
		close(sockfd);
		return -1;
	}

	/* Captura la senal SIGINT */
	if(signal(SIGINT,handle)==SIG_ERR)
	{
		error("ERROR: Fallo al capturar la senal SIGINT.\n");
	}

	/* While (TRUE) */
	while (1){

		/* Esperar conexion */
		n = sizeof(struct sockaddr_in);
		if ((newsockfd=accept(sockfd,(struct sockaddr*)&cli_addr,(socklen_t *) &n)) == -1){
			printf("Error en accept\n");
			continue;
		}
		/* procesar peticion */
		process_request(newsockfd);
	}
	close(sockfd);
	return 0; 
}

